/**
 * NOTE: This file is auto generated by Xendit.
 * Do not edit the class manually.
 * Improvements? Share your ideas at https://github.com/xendit/xendit-node
 */
/**
 *
 * @export
 * @interface FeeResponse
 */
export interface FeeResponse {
    /**
     * Amount of the Xendit fee for this transaction.
     * @type {number}
     * @memberof FeeResponse
     */
    xenditFee: number;
    /**
     * Amount of the VAT for this transaction.
     * @type {number}
     * @memberof FeeResponse
     */
    valueAddedTax: number;
    /**
     * Amount of the Xendit Withholding Tax for this transaction if applicable. See [Tax Documentation](https://docs.xendit.co/fees-and-vat#vat) for more information.
     * @type {number}
     * @memberof FeeResponse
     */
    xenditWithholdingTax?: number;
    /**
     * Amount of the 3rd Party Withholding Tax for this transaction if applicable. 3rd party example: Bank
     * @type {number}
     * @memberof FeeResponse
     */
    thirdPartyWithholdingTax?: number;
    /**
     *
     * @type {string}
     * @memberof FeeResponse
     */
    status?: FeeResponseStatusEnum;
}
/**
 * @export
 */
export declare const FeeResponseStatusEnum: {
    readonly Pending: "PENDING";
    readonly Completed: "COMPLETED";
    readonly Canceled: "CANCELED";
    readonly Reversed: "REVERSED";
};
export type FeeResponseStatusEnum = typeof FeeResponseStatusEnum[keyof typeof FeeResponseStatusEnum];
/**
 * Check if a given object implements the FeeResponse interface.
 */
export declare function instanceOfFeeResponse(value: object): boolean;
export declare function FeeResponseFromJSON(json: any): FeeResponse;
export declare function FeeResponseFromJSONTyped(json: any, ignoreDiscriminator: boolean): FeeResponse;
export declare function FeeResponseToJSON(value?: FeeResponse | null): any;
