/**
 * NOTE: This file is auto generated by Xendit.
 * Do not edit the class manually.
 * Improvements? Share your ideas at https://github.com/xendit/xendit-node
 */
import * as runtime from '../../runtime';
import type { Customer, CustomerRequest, GetCustomerByReferenceID200Response, PatchCustomer } from '../models';
export interface CreateCustomerRequest {
    idempotencyKey?: string;
    forUserId?: string;
    data?: CustomerRequest;
}
export interface GetCustomerRequest {
    id: string;
    forUserId?: string;
}
export interface GetCustomerByReferenceIDRequest {
    referenceId: string;
    forUserId?: string;
}
export interface UpdateCustomerRequest {
    id: string;
    forUserId?: string;
    data?: PatchCustomer;
}
/**
 *
 */
export declare class CustomerApi extends runtime.BaseAPI {
    secretKey: string;
    xenditURL: string;
    constructor({ secretKey, xenditURL }: {
        secretKey: string;
        xenditURL?: string;
    });
    /**
     * Function to create a customer that you may use in your Invoice or Payment Requests. For detail explanations, see this link: https://developers.xendit.co/api-reference/#create-customer
     * Create Customer
     */
    private createCustomerRaw;
    /**
     * Function to create a customer that you may use in your Invoice or Payment Requests. For detail explanations, see this link: https://developers.xendit.co/api-reference/#create-customer
     * Create Customer
     */
    createCustomer(requestParameters?: CreateCustomerRequest): Promise<Customer>;
    /**
     * Retrieves a single customer object For detail explanations, see this link: https://developers.xendit.co/api-reference/#get-customer
     * Get Customer By ID
     */
    private getCustomerRaw;
    /**
     * Retrieves a single customer object For detail explanations, see this link: https://developers.xendit.co/api-reference/#get-customer
     * Get Customer By ID
     */
    getCustomer(requestParameters: GetCustomerRequest): Promise<Customer>;
    /**
     * Retrieves an array with a customer object that matches the provided reference_id - the identifier provided by you For detail explanations, see this link: https://developers.xendit.co/api-reference/#get-customer-by-reference-id
     * GET customers by reference id
     */
    private getCustomerByReferenceIDRaw;
    /**
     * Retrieves an array with a customer object that matches the provided reference_id - the identifier provided by you For detail explanations, see this link: https://developers.xendit.co/api-reference/#get-customer-by-reference-id
     * GET customers by reference id
     */
    getCustomerByReferenceID(requestParameters: GetCustomerByReferenceIDRequest): Promise<GetCustomerByReferenceID200Response>;
    /**
     * Function to update an existing customer. For a detailed explanation For detail explanations, see this link: https://developers.xendit.co/api-reference/#update-customer
     * Update End Customer Resource
     */
    private updateCustomerRaw;
    /**
     * Function to update an existing customer. For a detailed explanation For detail explanations, see this link: https://developers.xendit.co/api-reference/#update-customer
     * Update End Customer Resource
     */
    updateCustomer(requestParameters: UpdateCustomerRequest): Promise<Customer>;
}
