/**
 * NOTE: This file is auto generated by Xendit.
 * Do not edit the class manually.
 * Improvements? Share your ideas at https://github.com/xendit/xendit-node
 */
/**
 *
 * @export
 * @interface IdentityAccountRequestProperties
 */
export interface IdentityAccountRequestProperties {
    /**
     * Unique account identifier as per the bank records.
     * @type {string}
     * @memberof IdentityAccountRequestProperties
     */
    accountNumber?: string;
    /**
     * Name of account holder as per the cardless credit account.
     * @type {string}
     * @memberof IdentityAccountRequestProperties
     */
    accountHolderName?: string | null;
    /**
     * The SWIFT code for international payments
     * @type {string}
     * @memberof IdentityAccountRequestProperties
     */
    swiftCode?: string | null;
    /**
     * Free text account type, e.g., Savings, Transaction, Virtual Account.
     * @type {string}
     * @memberof IdentityAccountRequestProperties
     */
    accountType?: string | null;
    /**
     * Potentially masked account detail, for display purposes only.
     * @type {string}
     * @memberof IdentityAccountRequestProperties
     */
    accountDetails?: string | null;
    /**
     *
     * @type {string}
     * @memberof IdentityAccountRequestProperties
     */
    currency?: string;
    /**
     * The token id returned in tokenisation
     * @type {string}
     * @memberof IdentityAccountRequestProperties
     */
    tokenId?: string;
    /**
     * Alphanumeric string identifying this account. Usually an email address or phone number.
     * @type {string}
     * @memberof IdentityAccountRequestProperties
     */
    accountId?: string;
    /**
     * Complete fixed payment code (including prefix)
     * @type {string}
     * @memberof IdentityAccountRequestProperties
     */
    paymentCode?: string;
    /**
     * YYYY-MM-DD string with expiry date for the payment code
     * @type {string}
     * @memberof IdentityAccountRequestProperties
     */
    expiresAt?: string | null;
    /**
     * String representation of the QR Code image
     * @type {string}
     * @memberof IdentityAccountRequestProperties
     */
    qrString?: string;
}
/**
 * Check if a given object implements the IdentityAccountRequestProperties interface.
 */
export declare function instanceOfIdentityAccountRequestProperties(value: object): boolean;
export declare function IdentityAccountRequestPropertiesFromJSON(json: any): IdentityAccountRequestProperties;
export declare function IdentityAccountRequestPropertiesFromJSONTyped(json: any, ignoreDiscriminator: boolean): IdentityAccountRequestProperties;
export declare function IdentityAccountRequestPropertiesToJSON(value?: IdentityAccountRequestProperties | null): any;
