/**
 * NOTE: This file is auto generated by Xendit.
 * Do not edit the class manually.
 * Improvements? Share your ideas at https://github.com/xendit/xendit-node
 */
/**
 *
 * @export
 * @interface IdentityAccountResponseProperties
 */
export interface IdentityAccountResponseProperties {
    /**
     * Unique account identifier as per the bank records.
     * @type {string}
     * @memberof IdentityAccountResponseProperties
     */
    accountNumber?: string;
    /**
     * Name of account holder as per the cardless credit account.
     * @type {string}
     * @memberof IdentityAccountResponseProperties
     */
    accountHolderName?: string | null;
    /**
     * The SWIFT code for international payments
     * @type {string}
     * @memberof IdentityAccountResponseProperties
     */
    swiftCode?: string | null;
    /**
     * Free text account type, e.g., Savings, Transaction, Virtual Account.
     * @type {string}
     * @memberof IdentityAccountResponseProperties
     */
    accountType?: string | null;
    /**
     * Potentially masked account detail, for display purposes only.
     * @type {string}
     * @memberof IdentityAccountResponseProperties
     */
    accountDetails?: string | null;
    /**
     *
     * @type {string}
     * @memberof IdentityAccountResponseProperties
     */
    currency?: string;
    /**
     * The token id returned in tokenisation
     * @type {string}
     * @memberof IdentityAccountResponseProperties
     */
    tokenId?: string;
    /**
     * Complete fixed payment code (including prefix)
     * @type {string}
     * @memberof IdentityAccountResponseProperties
     */
    paymentCode?: string;
    /**
     * YYYY-MM-DD string with expiry date for the payment code
     * @type {string}
     * @memberof IdentityAccountResponseProperties
     */
    expiresAt?: string | null;
    /**
     * String representation of the QR Code image
     * @type {string}
     * @memberof IdentityAccountResponseProperties
     */
    qrString?: string;
    /**
     * Alphanumeric string identifying this account. Usually an email address or phone number.
     * @type {string}
     * @memberof IdentityAccountResponseProperties
     */
    accountId?: string;
}
/**
 * Check if a given object implements the IdentityAccountResponseProperties interface.
 */
export declare function instanceOfIdentityAccountResponseProperties(value: object): boolean;
export declare function IdentityAccountResponsePropertiesFromJSON(json: any): IdentityAccountResponseProperties;
export declare function IdentityAccountResponsePropertiesFromJSONTyped(json: any, ignoreDiscriminator: boolean): IdentityAccountResponseProperties;
export declare function IdentityAccountResponsePropertiesToJSON(value?: IdentityAccountResponseProperties | null): any;
