# InvoiceCallback

Invoice Callback Object

## Properties

| Name | Type | Required | Description | Examples |
|------------|:-------------:|:-------------:|-------------|:-------------:|
| **id** |string | ☑️ | An invoice ID generated by Xendit | | |
| **externalId** |string | ☑️ | ID of your choice (typically the unique identifier of an invoice in your system) | | |
| **userId** |string | ☑️ | Xendit Business ID | | |
| **status** |string | ☑️ | The status of the invoice. | | |
| **merchantName** |string | ☑️ | The name of company or website | | |
| **amount** |number | ☑️ | Nominal amount for the invoice | | |
| **payerEmail** |string |  | Email of the payer | | |
| **description** |string |  | Description for the invoice | | |
| **paidAmount** |number |  | Total amount paid for the invoice | | |
| **created** |string | ☑️ | The date and time when the invoice was created. | | |
| **updated** |string | ☑️ | The date and time when the invoice was last updated. | | |
| **currency** |string | ☑️ | The currency of the invoice. | | |
| **paidAt** |string |  | The date and time when the invoice was paid. | | |
| **paymentMethod** |string |  | The payment method used for the invoice. | | |
| **paymentChannel** |string |  | The payment channel. | | |
| **paymentDestination** |string |  | The payment destination. | | |
| **paymentDetails** |[PaymentDetails](PaymentDetails.md) |  |  | | |
| **paymentId** |string |  | The ID of the payment. | | |
| **successRedirectUrl** |string |  | The URL to redirect to on successful payment. | | |
| **failureRedirectUrl** |string |  | The URL to redirect to on payment failure. | | |
| **creditCardChargeId** |string |  | The ID associated with a credit card charge (if applicable). | | |
| **items** |[InvoiceCallbackItem[]](InvoiceCallbackItem.md) |  |  | | |
| **fees** |[InvoiceFee[]](InvoiceFee.md) |  | An array of fees associated with the invoice. | | |
| **shouldAuthenticateCreditCard** |boolean |  | Indicates whether credit card authentication is required. | | |
| **bankCode** |string |  | The bank code for the bank details. | | |
| **ewalletType** |string |  | The type of eWallet. | | |
| **onDemandLink** |string |  | The on-demand link. | | |
| **recurringPaymentId** |string |  | The ID of the recurring payment. | | |



[[Back to README]](../../README.md)