export * from './runtime';
import { PaymentRequest } from './payment_request';
export { PaymentRequest } from './payment_request';
import { Invoice } from './invoice';
export { Invoice } from './invoice';
import { Transaction, Balance } from './balance_and_transaction';
export { Transaction, Balance } from './balance_and_transaction';
import { Refund } from './refund';
export { Refund } from './refund';
import { PaymentMethod } from './payment_method';
export { PaymentMethod } from './payment_method';
import { Payout } from './payout';
export { Payout } from './payout';
import { Customer } from './customer';
export { Customer } from './customer';
export interface XenditOpts {
    secretKey: string;
    xenditURL?: string;
}
export declare class Xendit {
    opts: XenditOpts;
    PaymentRequest: PaymentRequest;
    Invoice: Invoice;
    Transaction: Transaction;
    Balance: Balance;
    Refund: Refund;
    PaymentMethod: PaymentMethod;
    Payout: Payout;
    Customer: Customer;
    constructor({ secretKey: _secretKey, xenditURL: _xenditURL }: XenditOpts);
}
export default Xendit;
