/**
 * NOTE: This file is auto generated by Xendit.
 * Do not edit the class manually.
 * Improvements? Share your ideas at https://github.com/xendit/xendit-node
 */
import * as runtime from '../../runtime';
import type { PaymentMethod, PaymentMethodAuthParameters, PaymentMethodExpireParameters, PaymentMethodList, PaymentMethodParameters, PaymentMethodReusability, PaymentMethodStatus, PaymentMethodType, PaymentMethodUpdateParameters, SimulatePaymentRequest } from '../models';
export interface CreatePaymentMethodRequest {
    forUserId?: string;
    data?: PaymentMethodParameters;
}
export interface GetPaymentMethodByIDRequest {
    paymentMethodId: string;
    forUserId?: string;
}
export interface GetPaymentsByPaymentMethodIdRequest {
    paymentMethodId: string;
    forUserId?: string;
    paymentRequestId?: Array<string>;
    paymentMethodId2?: Array<string>;
    referenceId?: Array<string>;
    paymentMethodType?: Array<PaymentMethodType>;
    channelCode?: Array<string>;
    status?: Array<string>;
    currency?: Array<string>;
    createdGte?: Date;
    createdLte?: Date;
    updatedGte?: Date;
    updatedLte?: Date;
    limit?: number;
}
export interface PatchPaymentMethodRequest {
    paymentMethodId: string;
    forUserId?: string;
    data?: PaymentMethodUpdateParameters;
}
export interface GetAllPaymentMethodsRequest {
    forUserId?: string;
    id?: Array<string>;
    type?: Array<string>;
    status?: Array<PaymentMethodStatus>;
    reusability?: PaymentMethodReusability;
    customerId?: string;
    referenceId?: string;
    afterId?: string;
    beforeId?: string;
    limit?: number;
}
export interface ExpirePaymentMethodRequest {
    paymentMethodId: string;
    forUserId?: string;
    data?: PaymentMethodExpireParameters | null;
}
export interface AuthPaymentMethodRequest {
    paymentMethodId: string;
    forUserId?: string;
    data?: PaymentMethodAuthParameters;
}
export interface SimulatePaymentOperationRequest {
    paymentMethodId: string;
    data?: SimulatePaymentRequest;
}
/**
 *
 */
export declare class PaymentMethodApi extends runtime.BaseAPI {
    secretKey: string;
    xenditURL: string;
    constructor({ secretKey, xenditURL }: {
        secretKey: string;
        xenditURL?: string;
    });
    /**
     * This endpoint initiates creation of payment method
     * Creates payment method
     */
    private createPaymentMethodRaw;
    /**
     * This endpoint initiates creation of payment method
     * Creates payment method
     */
    createPaymentMethod(requestParameters?: CreatePaymentMethodRequest): Promise<PaymentMethod>;
    /**
     * Get payment method by ID
     * Get payment method by ID
     */
    private getPaymentMethodByIDRaw;
    /**
     * Get payment method by ID
     * Get payment method by ID
     */
    getPaymentMethodByID(requestParameters: GetPaymentMethodByIDRequest): Promise<PaymentMethod>;
    /**
     * Returns payments with matching PaymentMethodID.
     * Returns payments with matching PaymentMethodID.
     */
    private getPaymentsByPaymentMethodIdRaw;
    /**
     * Returns payments with matching PaymentMethodID.
     * Returns payments with matching PaymentMethodID.
     */
    getPaymentsByPaymentMethodId(requestParameters: GetPaymentsByPaymentMethodIdRequest): Promise<object>;
    /**
     * This endpoint is used to toggle the ```status``` of an e-Wallet or a Direct Debit payment method to ```ACTIVE``` or ```INACTIVE```. This is also used to update the details of an Over-the-Counter or a Virtual Account payment method.
     * Patch payment methods
     */
    private patchPaymentMethodRaw;
    /**
     * This endpoint is used to toggle the ```status``` of an e-Wallet or a Direct Debit payment method to ```ACTIVE``` or ```INACTIVE```. This is also used to update the details of an Over-the-Counter or a Virtual Account payment method.
     * Patch payment methods
     */
    patchPaymentMethod(requestParameters: PatchPaymentMethodRequest): Promise<PaymentMethod>;
    /**
     * Get all payment methods by filters
     * Get all payment methods by filters
     */
    private getAllPaymentMethodsRaw;
    /**
     * Get all payment methods by filters
     * Get all payment methods by filters
     */
    getAllPaymentMethods(requestParameters?: GetAllPaymentMethodsRequest): Promise<PaymentMethodList>;
    /**
     * This endpoint expires a payment method and performs unlinking if necessary
     * Expires a payment method
     */
    private expirePaymentMethodRaw;
    /**
     * This endpoint expires a payment method and performs unlinking if necessary
     * Expires a payment method
     */
    expirePaymentMethod(requestParameters: ExpirePaymentMethodRequest): Promise<PaymentMethod>;
    /**
     * This endpoint validates a payment method linking OTP
     * Validate a payment method\'s linking OTP
     */
    private authPaymentMethodRaw;
    /**
     * This endpoint validates a payment method linking OTP
     * Validate a payment method\'s linking OTP
     */
    authPaymentMethod(requestParameters: AuthPaymentMethodRequest): Promise<PaymentMethod>;
    /**
     * Makes payment with matching PaymentMethodID.
     * Makes payment with matching PaymentMethodID.
     */
    private simulatePaymentRaw;
    /**
     * Makes payment with matching PaymentMethodID.
     * Makes payment with matching PaymentMethodID.
     */
    simulatePayment(requestParameters: SimulatePaymentOperationRequest): Promise<void>;
}
