/**
 * NOTE: This file is auto generated by Xendit.
 * Do not edit the class manually.
 * Improvements? Share your ideas at https://github.com/xendit/xendit-node
 */
/**
 * Tokenized Card Information
 * @export
 * @interface TokenizedCardInformation
 */
export interface TokenizedCardInformation {
    /**
     *
     * @type {string}
     * @memberof TokenizedCardInformation
     */
    tokenId: string;
    /**
     * 1st 6 and last 4 digits of the card
     * @type {string}
     * @memberof TokenizedCardInformation
     */
    maskedCardNumber: string;
    /**
     * Cardholder name is optional but recommended for 3DS 2 / AVS verification
     * @type {string}
     * @memberof TokenizedCardInformation
     */
    cardholderName?: string | null;
    /**
     * Card expiry month in MM format
     * @type {string}
     * @memberof TokenizedCardInformation
     */
    expiryMonth: string;
    /**
     * Card expiry month in YY format
     * @type {string}
     * @memberof TokenizedCardInformation
     */
    expiryYear: string;
    /**
     * Xendit-generated identifier for the unique card number. Multiple payment method objects can be created for the same account - e.g. if the user first creates a one-time payment request, and then later on creates a multiple-use payment method using the same account.   The fingerprint helps to identify the unique account being used.
     * @type {string}
     * @memberof TokenizedCardInformation
     */
    fingerprint: string;
    /**
     * Whether the card is a credit or debit card
     * @type {string}
     * @memberof TokenizedCardInformation
     */
    type: string;
    /**
     * Card network - VISA, MASTERCARD, JCB, AMEX, DISCOVER, BCA
     * @type {string}
     * @memberof TokenizedCardInformation
     */
    network: string;
    /**
     * Country where the card was issued ISO 3166-1 Alpha-2
     * @type {string}
     * @memberof TokenizedCardInformation
     */
    country: string;
    /**
     * Issuer of the card, most often an issuing bank For example, “BCA”, “MANDIRI”
     * @type {string}
     * @memberof TokenizedCardInformation
     */
    issuer: string;
}
/**
 * Check if a given object implements the TokenizedCardInformation interface.
 */
export declare function instanceOfTokenizedCardInformation(value: object): boolean;
export declare function TokenizedCardInformationFromJSON(json: any): TokenizedCardInformation;
export declare function TokenizedCardInformationFromJSONTyped(json: any, ignoreDiscriminator: boolean): TokenizedCardInformation;
export declare function TokenizedCardInformationToJSON(value?: TokenizedCardInformation | null): any;
