/**
 * NOTE: This file is auto generated by Xendit.
 * Do not edit the class manually.
 * Improvements? Share your ideas at https://github.com/xendit/xendit-node
 */
import type { DigitalPayoutChannelProperties } from './DigitalPayoutChannelProperties';
import type { ReceiptNotification } from './ReceiptNotification';
/**
 * Information needed by Xendit to send money to the destination channel provided
 * @export
 * @interface CreatePayoutRequest
 */
export interface CreatePayoutRequest {
    /**
     * A client defined payout identifier
     * @type {string}
     * @memberof CreatePayoutRequest
     */
    referenceId: string;
    /**
     * Channel code of selected destination bank or e-wallet
     * @type {string}
     * @memberof CreatePayoutRequest
     */
    channelCode: string;
    /**
     *
     * @type {DigitalPayoutChannelProperties}
     * @memberof CreatePayoutRequest
     */
    channelProperties: DigitalPayoutChannelProperties;
    /**
     * Amount to be sent to the destination account and should be a multiple of the minimum increment for the selected channel
     * @type {number}
     * @memberof CreatePayoutRequest
     */
    amount: number;
    /**
     * Description to send with the payout, the recipient may see this e.g., in their bank statement (if supported) or in email receipts we send on your behalf
     * @type {string}
     * @memberof CreatePayoutRequest
     */
    description?: string;
    /**
     * Currency of the destination channel using ISO-4217 currency code
     * @type {string}
     * @memberof CreatePayoutRequest
     */
    currency: string;
    /**
     *
     * @type {ReceiptNotification}
     * @memberof CreatePayoutRequest
     */
    receiptNotification?: ReceiptNotification;
    /**
     * Object of additional information you may use
     * @type {object}
     * @memberof CreatePayoutRequest
     */
    metadata?: object;
}
/**
 * Check if a given object implements the CreatePayoutRequest interface.
 */
export declare function instanceOfCreatePayoutRequest(value: object): boolean;
export declare function CreatePayoutRequestFromJSON(json: any): CreatePayoutRequest;
export declare function CreatePayoutRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): CreatePayoutRequest;
export declare function CreatePayoutRequestToJSON(value?: CreatePayoutRequest | null): any;
