/**
 * NOTE: This file is auto generated by Xendit.
 * Do not edit the class manually.
 * Improvements? Share your ideas at https://github.com/xendit/xendit-node
 */
import type { DigitalPayoutChannelProperties } from './DigitalPayoutChannelProperties';
import type { ReceiptNotification } from './ReceiptNotification';
/**
 *
 * @export
 * @interface GetPayouts200ResponseDataInner
 */
export interface GetPayouts200ResponseDataInner {
    /**
     * A client defined payout identifier
     * @type {string}
     * @memberof GetPayouts200ResponseDataInner
     */
    referenceId: string;
    /**
     * Channel code of selected destination bank or e-wallet
     * @type {string}
     * @memberof GetPayouts200ResponseDataInner
     */
    channelCode: string;
    /**
     *
     * @type {DigitalPayoutChannelProperties}
     * @memberof GetPayouts200ResponseDataInner
     */
    channelProperties: DigitalPayoutChannelProperties;
    /**
     * Amount to be sent to the destination account and should be a multiple of the minimum increment for the selected channel
     * @type {number}
     * @memberof GetPayouts200ResponseDataInner
     */
    amount: number;
    /**
     * Description to send with the payout, the recipient may see this e.g., in their bank statement (if supported) or in email receipts we send on your behalf
     * @type {string}
     * @memberof GetPayouts200ResponseDataInner
     */
    description?: string;
    /**
     * Currency of the destination channel using ISO-4217 currency code
     * @type {string}
     * @memberof GetPayouts200ResponseDataInner
     */
    currency: string;
    /**
     *
     * @type {ReceiptNotification}
     * @memberof GetPayouts200ResponseDataInner
     */
    receiptNotification?: ReceiptNotification;
    /**
     * Object of additional information you may use
     * @type {object}
     * @memberof GetPayouts200ResponseDataInner
     */
    metadata?: object;
    /**
     * Xendit-generated unique identifier for each payout
     * @type {string}
     * @memberof GetPayouts200ResponseDataInner
     */
    id: string;
    /**
     * The time payout was created on Xendit's system, in ISO 8601 format
     * @type {Date}
     * @memberof GetPayouts200ResponseDataInner
     */
    created: Date;
    /**
     * The time payout was last updated on Xendit's system, in ISO 8601 format
     * @type {Date}
     * @memberof GetPayouts200ResponseDataInner
     */
    updated: Date;
    /**
     * Xendit Business ID
     * @type {string}
     * @memberof GetPayouts200ResponseDataInner
     */
    businessId: string;
    /**
     * Status of payout
     * @type {string}
     * @memberof GetPayouts200ResponseDataInner
     */
    status: GetPayouts200ResponseDataInnerStatusEnum;
    /**
     * If the Payout failed, we include a failure code for more details on the failure.
     * @type {string}
     * @memberof GetPayouts200ResponseDataInner
     */
    failureCode?: GetPayouts200ResponseDataInnerFailureCodeEnum;
    /**
     * Our estimated time on to when your payout is reflected to the destination account
     * @type {Date}
     * @memberof GetPayouts200ResponseDataInner
     */
    estimatedArrivalTime?: Date;
}
/**
 * @export
 */
export declare const GetPayouts200ResponseDataInnerStatusEnum: {
    readonly Succeeded: "SUCCEEDED";
    readonly Failed: "FAILED";
    readonly Accepted: "ACCEPTED";
    readonly Requested: "REQUESTED";
    readonly Locked: "LOCKED";
    readonly Cancelled: "CANCELLED";
    readonly Reversed: "REVERSED";
};
export type GetPayouts200ResponseDataInnerStatusEnum = typeof GetPayouts200ResponseDataInnerStatusEnum[keyof typeof GetPayouts200ResponseDataInnerStatusEnum];
/**
 * @export
 */
export declare const GetPayouts200ResponseDataInnerFailureCodeEnum: {
    readonly InsufficientBalance: "INSUFFICIENT_BALANCE";
    readonly RejectedByChannel: "REJECTED_BY_CHANNEL";
    readonly TemporaryTransferError: "TEMPORARY_TRANSFER_ERROR";
    readonly InvalidDestination: "INVALID_DESTINATION";
    readonly TransferError: "TRANSFER_ERROR";
};
export type GetPayouts200ResponseDataInnerFailureCodeEnum = typeof GetPayouts200ResponseDataInnerFailureCodeEnum[keyof typeof GetPayouts200ResponseDataInnerFailureCodeEnum];
/**
 * Check if a given object implements the GetPayouts200ResponseDataInner interface.
 */
export declare function instanceOfGetPayouts200ResponseDataInner(value: object): boolean;
export declare function GetPayouts200ResponseDataInnerFromJSON(json: any): GetPayouts200ResponseDataInner;
export declare function GetPayouts200ResponseDataInnerFromJSONTyped(json: any, ignoreDiscriminator: boolean): GetPayouts200ResponseDataInner;
export declare function GetPayouts200ResponseDataInnerToJSON(value?: GetPayouts200ResponseDataInner | null): any;
